use aoc_runner_derive::{aoc, aoc_generator};
use regex::Regex;
#[aoc_generator(day3)]
fn parse(input: &str) -> String {
    input.to_string()
}

#[aoc(day3, part1)]
fn part1(input: &str) -> i64 {
    Regex::new(r"mul\((?<a>[0-9]{1,3}),(?<b>[0-9]{1,3})\)")
        .unwrap()
        .captures_iter(input)
        .fold(0, |a, c| {
            a + c.get(1).unwrap().as_str().parse::<i64>().unwrap()
                * c.get(2).unwrap().as_str().parse::<i64>().unwrap()
        })
}

#[aoc(day3, part2)]
fn part2(input: &str) -> i64 {
    Regex::new(r"mul\((?<a>[0-9]{1,3}),(?<b>[0-9]{1,3})\)|do\(\)|don't\(\)")
        .unwrap()
        .captures_iter(input)
        .fold((true, 0i64), |a, c| match c.get(0).unwrap().as_str() {
            "do()" => (true, a.1),
            "don't()" => (false, a.1),
            _ => {
                if a.0 {
                    (
                        a.0,
                        a.1 + c.get(1).unwrap().as_str().parse::<i64>().unwrap()
                            * c.get(2).unwrap().as_str().parse::<i64>().unwrap(),
                    )
                } else {
                    a
                }
            }
        })
        .1
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn part1_example() {
        assert_eq!(
            part1(&parse(
                "xmul(2,4)%&mul[3,7]!@^do_not_mul(5,5)+mul(32,64]then(mul(11,8)mul(8,5))
"
            )),
            161
        );
    }

    #[test]
    fn part2_example() {
        assert_eq!(
            part2(&parse(
                "xmul(2,4)&mul[3,7]!^don't()_mul(5,5)+mul(32,64](mul(11,8)undo()?mul(8,5))"
            )),
            48
        );
    }
}
